import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Organization, OrganizationParam } from './model';
import {SERVER_API_URL} from "@/utils/server";

/**
 * 分页查询机构
 */
export async function pageOrganizations(params: OrganizationParam) {
  const res = await request.get<ApiResult<PageResult<Organization>>>(
    SERVER_API_URL + '/system/organization/page',
    { params }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询机构列表
 */
export async function listOrganizations(params?: OrganizationParam) {
  const res = await request.get<ApiResult<Organization[]>>(
    SERVER_API_URL + '/system/organization',
    { params }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加机构
 */
export async function addOrganization(data: Organization) {
  const res = await request.post<ApiResult<unknown>>(
    SERVER_API_URL + '/system/organization',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改机构
 */
export async function updateOrganization(data: Organization) {
  const res = await request.put<ApiResult<unknown>>(
    SERVER_API_URL + '/system/organization',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除机构
 */
export async function removeOrganization(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    SERVER_API_URL + '/system/organization/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询机构
 */
export async function getOrganization(id: number) {
  const res = await request.get<ApiResult<Organization>>(
    SERVER_API_URL + '/system/organization/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
